Leetcode Distinct Subsequences

13 篇文章 0 订阅

  题目要求:


Given a string S and a string T, count the number of distinct subsequences of T in S.

A subsequence of a string is a new string which is formed from the original string by deleting some (can be none) of the characters without disturbing the relative positions of the remaining characters. (ie, "ACE" is a subsequence of "ABCDE" while "AEC" is not).

Here is an example:
S = "rabbbit"T = "rabbit"

Return 3.

就是找T 在S中出现的个数。 这道题目是个DP问题, 我们用dp[i][j] 这个数组记录S和T 在i和j位置出现字串的数目。 初始化的时候 dp[0][0...m]=1(m是S的长度,表示T为空的时候,子串的数目为1), dp[1...n][0] = 0(n是T的长度,表示S为空的时候,T在S中出现此时为0), 所以在 i, j位置时候子串的数目至少等于dp[i][j - 1],如果T[i] == S[j],dp[i][j] 的数目还要加上dp[i - 1][j - 1]。

所以递推式:dp[i][j] = dp[i][j] + (T[i] == S[j] ? dp[i - 1][j - 1] : 0);

S ="rabbbit",T = "rabbit"为例:

    r a b b b i t

  1 1 1 1 1 1 1 1

0 1 1 1 1 1 1 1

a 0 1 1 1 1

b 0 0 2 3 3 3

b 0 0 0 0 3 3 3

i 0 0 0 0 0 0 3 3

t 0 0 0 0 0 0 0 3  

代码:

class Solution {
public:
    int numDistinct(string S, string T) {
        int m = S.size();
        int n = T.size();
        int dp[n + 1][m + 1];
        memset(dp, 0, sizeof(dp));
        for(int i = 0; i <= m; ++i)
            dp[0][i] = 1;
        // dp[i][j] = dp[i][j] + (T[i - 1] == S[j - 1] ? dp[i - 1][j - 1] : 0);
        for(int i = 1; i <= n; ++i)
            for(int j = 1; j <= m; ++j)
            {
                dp[i][j] = dp[i][j - 1];
                if(T[i - 1] == S[j - 1])
                    dp[i][j] += dp[i - 1][j - 1];
            }
        return dp[n][m];
    }
};



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值